<?php
/*
Plugin Name: customToolbox
Plugin URI: http://fredpointzero.com/plugins-wordpress/custom-toolbox/
Description: toolbox for customizing your wordpress
Version: 0.1
Author: Frederic Vauchelles, Cathy Vauchelles
Author URI: http://fredpointzero.com
Text Domain: custom-toolbox

  Copyright 2009 customToolbox  (email : fredpointzero@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
class customTooblox {
	// Singleton pattern
	private function __construct(){
		// Hook - DB
		add_option('customToolbox');
		// Hook - process request on init
		add_action( 'init', array( $this, 'init' ) );
		
		if ( is_admin() ){
			// Admin generation menu
			add_action( 'admin_init', array( $this, 'admin_init' ) );
			add_action( 'admin_menu', array( $this, 'admin_menu' ) );
		} else {
			$this->add_count_comments_filter();
		}
	}
	private static $instance = null;
	public static function getInstance(){
		if ( null === self::$instance )
			self::$instance = new customTooblox();
		return self::$instance;
	}
	// Hook functions
	public function init() {
		load_plugin_textdomain( 'custom-toolbox', null, 'customToolbox/lang' );
	}
	public function admin_init(){
		register_setting( 'custom-toolbox-options', 'customToolbox' );
	}
	public function admin_menu(){
		add_options_page(
			__('Custom Toolbox', 'custom-toolbox'),
			__('Custom Toolbox', 'custom-toolbox'),
			8,
			'cutom-toolbox',
			array( $this, 'admin_generate_main' )
		);
	}
	// Rendering
	public function admin_generate_main(){
		include( dirname(__FILE__).'/admin_menu.php' );
	}
	// Default options
	public static $defaultOptions = array(
		'count_comments' => null,
		'count_comments_tpl' => '#%i - %content'
	);
	// Tools
	// Comment count
	/**
	 *	Filter comments :
	 *	Use the template given to render the comment
	 *	@param string $text : text of the filter
	 */
	public function count_comments_filter($text){
		$options = get_option( 'customToolbox' );
		$options = array_merge(
			self::$defaultOptions,
			$options
		);
		static $i = 0;
		return str_replace(
			array(
				'%i',
				'%content'
			),
			array(
				$i++,
				$text
			),
			$options['count_comments_tpl']
		);
	}
	// Posible locations of the comment (defined at the end of the file)
	public static $count_comment_location = array();
	// Filters
	/**
	 *	Add count comment filter if it is requested by the user
	 */
	public function add_count_comments_filter(){
		$options = get_option( 'customToolbox' );
		$options = array_merge(
			self::$defaultOptions,
			$options
		);
		if ( $options['count_comments'] != null && in_array( $options['count_comments'], self::$count_comment_location ) )
			add_filter( $options['count_comments'], array( $this, 'count_comments_filter' ) );
	}
}
customTooblox::$count_comment_location = array(
	__('None', 'custom-toolbox') => null,
	__('Author', 'custom-toolbox') => 'get_comment_author',
	__('Text', 'custom-toolbox') => 'get_comment_text'
);
customTooblox::getInstance();
?>